CREATE TABLE IF NOT EXISTS `{#}grades_log` (
  `id` bigint(20) NOT NULL AUTO_INCREMENT,
  `user_id` int(11) DEFAULT NULL COMMENT 'ID пользователя',
  `target_controller` varchar(32) DEFAULT NULL COMMENT 'Компонент (владелец оцениваемого контента)',
  `target_subject` varchar(32) DEFAULT NULL COMMENT 'Субъект (тип оцениваемого контента)',
  `target_id` int(11) DEFAULT NULL COMMENT 'ID субъекта (записи оцениваемого контента)',
  `score` tinyint(4) DEFAULT NULL COMMENT 'Значение оценки',
  PRIMARY KEY (`id`),
  KEY `user_id` (`user_id`),
  KEY `target_controller` (`target_controller`),
  KEY `target_type` (`target_subject`),
  KEY `target_id` (`target_id`)
) ENGINE=InnoDB  DEFAULT CHARSET=utf8 COMMENT='Оценки полезности страниц' AUTO_INCREMENT=1 ;

INSERT INTO `{#}controllers` (`title`, `name`, `is_enabled`, `options`, `author`, `url`, `version`, `is_backend`) VALUES
('Полезность страниц', 'grades', 1, '---\nis_hidden: 1\nis_show: 1\n', 'Alex Malinsky', 'http://www.codeplace.ru', '2.0', 1);

INSERT INTO `{#}perms_rules` (`controller`, `name`, `type`, `options`) VALUES
('content', 'grades_on', 'flag', NULL);