<?php

class modelgrades extends cmsModel{
    
    public function getGradesTarget($model, $ctype_name, $id){
		
        $table_name = $model->table_prefix . $ctype_name;

        $item = $this->getItemById($table_name, $id);

        return $item;

    }  
    
 
    public function updateGrades($model, $ctype_name, $id, $grades){

        $table_name = $model->table_prefix . $ctype_name;

        $this->update($table_name, $id, array('grades' => $grades));

        cmsCache::getInstance()->clean("content.list.{$ctype_name}");
        cmsCache::getInstance()->clean("content.item.{$ctype_name}");

    }  

    

//============================================================================//
//============================================================================//

    public function isUserVoted($vote){

        $this->filterEqual('user_id', $vote['user_id']);
        $this->filterEqual('target_controller', $vote['target_controller']);
        $this->filterEqual('target_subject', $vote['target_subject']);
        $this->filterEqual('target_id', $vote['target_id']);

        $this->useCache("grades.votes");

        $votes_count = $this->getCount('grades_log');

        $this->resetFilters();

        return $votes_count > 0 ? true : false;

    }

//============================================================================//
//============================================================================//

    public function filterVotes($controller, $subject, $id){

        $this->filterEqual('target_subject', $subject);
        $this->filterEqual('target_id', $id);

        return $this;

    }
    
    public function getCurrentVotes($subject, $id){

        $this->filterEqual('target_subject', $subject);
        $this->filterEqual('target_id', $id);

        return $this->get('grades_log');

    }
    
        public function getCurrentVotesCount($subject, $id){

        $this->filterEqual('target_subject', $subject);
        $this->filterEqual('target_id', $id);

        return $this->getCount('grades_log');

    }

    public function getVotesCount(){

        return $this->getCount('grades_log');

    }
    
    public function getVotes(){

        $this->useCache("grades.votes");

        $this->joinUser();

        return $this->get('grades_log', function($item, $model){

            $item['user'] = array(
                'id' => $item['user_id'],
                'nickname' => $item['user_nickname'],
                'avatar' => $item['user_avatar']
            );

            return $item;

        });

    }

//============================================================================//
//============================================================================//

    public function addVote($vote){

        cmsCache::getInstance()->clean("grades.votes");

        return $this->insert('grades_log', $vote);

    }

//============================================================================//
//============================================================================//

    public function deleteVotes($controller, $subject, $id){

        $this->filterVotes($controller, $subject, $id);

        $this->deleteFiltered('grades_log');

        cmsCache::getInstance()->clean("grades.votes");

    }

    public function deleteUserVotes($user_id){

        cmsCache::getInstance()->clean("grades.votes");

        return $this->delete('grades_log', $user_id, 'user_id');

    }

//============================================================================//
//============================================================================//

}
